- set PGPORT
[myplc.git] / host.init
index 0c101e2..cba4101 100755 (executable)
--- a/host.init
+++ b/host.init
@@ -6,7 +6,7 @@
 #
 # description: Manages all PLC services on this machine
 #
-# $Id: plc.init,v 1.6 2005/04/24 19:48:11 mlhuang Exp $
+# $Id: host.init,v 1.2 2006/03/27 22:01:36 mlhuang Exp $
 #
 
 PATH=/sbin:/bin:/usr/bin:/usr/sbin
@@ -15,92 +15,89 @@ PATH=/sbin:/bin:/usr/bin:/usr/sbin
 . /etc/init.d/functions
 
 # Source configuration
-if [ -f /etc/sysconfig/plc ] ; then
+if [ -f /etc/sysconfig/plc -a -z "${PLC_ROOT}${PLC_DATA}" ] ; then
     . /etc/sysconfig/plc
 fi
 
-RETVAL=0
-
-# Get options
-while getopts "vh" opt ; do
-    case $opt in
-       v)
-           verbose=1
-           set -x
-           ;;
-       h|*)
-           usage
-           ;;
-    esac
-done
+# Total number of errors
+ERRORS=0
+
+# Count the exit status of the last command
+check ()
+{
+    ERRORS=$(($ERRORS+$?))
+}
+
+mounted ()
+{
+    if cut -d' ' -f2 /proc/mounts | grep -q "$1" ; then
+       return 0
+    else
+       return 1
+    fi
+}
 
 start ()
 {
     echo -n $"Mounting PLC: "
 
-    if ! grep -q $PLC_ROOT.img /proc/mounts ; then
+    if ! mounted $PLC_ROOT ; then
        if ! e2fsck -a $PLC_ROOT.img | logger -t "PLC" ; then
            e2fsck $PLC_ROOT.img
        fi
        mount -o loop $PLC_ROOT.img $PLC_ROOT
-       RETVAL=$(($RETVAL+$?))
+       check
     fi
-    if ! grep -q $PLC_DATA /proc/mounts ; then
+    if ! mounted $PLC_ROOT/data ; then
        mount -t none -o bind,rw $PLC_DATA $PLC_ROOT/data
-       RETVAL=$(($RETVAL+$?))
+       check
     fi
-    if ! grep -q $PLC_ROOT/proc /proc/mounts ; then
+    if ! mounted $PLC_ROOT/proc ; then
        mount -t proc none $PLC_ROOT/proc
-       RETVAL=$(($RETVAL+$?))
+       check
     fi
 
-    if [ $RETVAL -eq 0 ]; then
-       success $"PLC mount"
-    else
-       failure $"PLC mount"
-    fi
+    [ $ERRORS -eq 0 ] && success $"PLC unmount" || failure $"PLC unmount"      
     echo
 
     chroot $PLC_ROOT /sbin/service plc $PLC_OPTIONS start
-    RETVAL=$?
+    check
 }
 
 stop ()
 {
-    chroot $PLC_ROOT /sbin/service plc $PLC_OPTIONS stop
+    if mounted $PLC_ROOT ; then
+       chroot $PLC_ROOT /sbin/service plc $PLC_OPTIONS stop
+       check
+    fi
 
     echo -n $"Unmounting PLC: "
 
-    umount $PLC_ROOT/proc
-    RETVAL=$(($RETVAL+$?))
-    umount $PLC_ROOT/data
-    RETVAL=$(($RETVAL+$?))
-    umount $PLC_ROOT
-    RETVAL=$(($RETVAL+$?))
+    for dir in $PLC_ROOT/proc $PLC_ROOT/data $PLC_ROOT ; do
+       if mounted $dir ; then
+           umount $dir
+           check
+       fi
+    done
 
-    if [ $RETVAL -eq 0 ]; then
-       success $"PLC unmount"
-    else
-       failure $"PLC unmount"  
-    fi
+    [ $ERRORS -eq 0 ] && success $"PLC unmount" || failure $"PLC unmount"      
     echo
 }
 
-restart ()
-{
-    stop
-    start
-}
-
 case "$1" in
-    start|stop|restart)
+    start|stop)
        $1
        ;;
 
+    restart)
+       stop
+       start
+       ;;
+
     *)
        echo "Usage: $0 {start|stop|restart}"
        RETVAL=1
        ;;
 esac
 
-exit $RETVAL
+exit $ERRORS